Index: branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90
===================================================================
--- branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 7308)
+++ branches/2016/dev_CNRS_AGRIF_2016/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 7309)
@@ -22,22 +22,21 @@
    USE phycst         ! physical constants
    USE dom_oce        ! ocean space and time domain variables
-   USE ice            ! LIM: sea-ice variables
+   USE ice            ! sea-ice variables
    USE sbc_oce        ! Surface boundary condition: ocean fields
    USE sbc_ice        ! Surface boundary condition: ice fields
-   USE dom_ice        ! LIM: sea-ice domain
-   USE thd_ice        ! LIM: thermodynamic sea-ice variables
-   USE limthd_dif     ! LIM: thermodynamics, vertical diffusion
-   USE limthd_dh      ! LIM: thermodynamics, ice and snow thickness variation
-   USE limthd_sal     ! LIM: thermodynamics, ice salinity
-   USE limthd_ent     ! LIM: thermodynamics, ice enthalpy redistribution
-   USE limthd_lac     ! LIM: lateral accretion
-   USE limitd_th      ! LIM: remapping thickness distribution
-   USE limtab         ! LIM: 1D <==> 2D transformation
-   USE limvar         ! LIM: sea-ice variables
-   USE limcons        ! LIM: conservation tests
-   USE limctl         ! LIM: control print
+   USE thd_ice        ! thermodynamic sea-ice variables
+   USE limthd_dif     ! vertical diffusion
+   USE limthd_dh      ! ice-snow growth and melt
+   USE limthd_da      ! lateral melting
+   USE limthd_sal     ! ice salinity
+   USE limthd_ent     ! ice enthalpy redistribution
+   USE limthd_lac     ! lateral accretion
+   USE limitd_th      ! remapping thickness distribution
+   USE limtab         ! 1D <==> 2D transformation
+   USE limvar         !
+   USE limcons        ! conservation tests
+   USE limctl         ! control print
    !
    USE in_out_manager ! I/O manager
-   USE prtctl         ! Print control
    USE lbclnk         ! lateral boundary condition - MPP links
    USE lib_mpp        ! MPP library
@@ -88,20 +87,52 @@
       REAL(wp), PARAMETER :: zfric_umin = 0._wp           ! lower bound for the friction velocity (cice value=5.e-04)
       REAL(wp), PARAMETER :: zch        = 0.0057_wp       ! heat transfer coefficient
+      REAL(wp), POINTER, DIMENSION(:,:) ::   zu_io, zv_io, zfric   ! ice-ocean velocity (m/s) and frictional velocity (m2/s2)
+      !
       !!-------------------------------------------------------------------
 
       IF( nn_timing == 1 )   CALL timing_start('limthd')
 
+      CALL wrk_alloc( jpi,jpj, zu_io, zv_io, zfric )
+
+      IF( kt == nit000 .AND. lwp ) THEN
+         WRITE(numout,*)'' 
+         WRITE(numout,*)' lim_thd '
+         WRITE(numout,*)' ~~~~~~~~'
+      ENDIF
+      
       ! conservation test
-      IF( ln_limdiahsb )   CALL lim_cons_hsm( 0, 'limthd', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b )
+      IF( ln_limdiachk ) CALL lim_cons_hsm(0, 'limthd', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
       CALL lim_var_glo2eqv
-      !------------------------------------------------------------------------!
-      ! 1) Initialization of some variables                                    !
-      !------------------------------------------------------------------------!
+
+      !---------------------------------------------!
+      ! computation of friction velocity at T points
+      !---------------------------------------------!
+      IF( ln_limdyn ) THEN
+         zu_io(:,:) = u_ice(:,:) - ssu_m(:,:)
+         zv_io(:,:) = v_ice(:,:) - ssv_m(:,:)
+         DO jj = 2, jpjm1 
+            DO ji = fs_2, fs_jpim1
+               zfric(ji,jj) = rn_cio * ( 0.5_wp *  &
+                  &                    (  zu_io(ji,jj) * zu_io(ji,jj) + zu_io(ji-1,jj) * zu_io(ji-1,jj)   &
+                  &                     + zv_io(ji,jj) * zv_io(ji,jj) + zv_io(ji,jj-1) * zv_io(ji,jj-1) ) ) * tmask(ji,jj,1)
+            END DO
+         END DO
+      ELSE      !  if no ice dynamics => transmit directly the atmospheric stress to the ocean
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1
+               zfric(ji,jj) = r1_rau0 * SQRT( 0.5_wp *  &
+                  &                         (  utau(ji,jj) * utau(ji,jj) + utau(ji-1,jj) * utau(ji-1,jj)   &
+                  &                          + vtau(ji,jj) * vtau(ji,jj) + vtau(ji,jj-1) * vtau(ji,jj-1) ) ) * tmask(ji,jj,1)
+            END DO
+         END DO
+      ENDIF
+      CALL lbc_lnk( zfric, 'T',  1. )
+      !
+      !----------------------------------!
+      ! Initialization and units change
+      !----------------------------------!
       ftr_ice(:,:,:) = 0._wp  ! part of solar radiation transmitted through the ice
 
-      !--------------------
-      ! 1.2) Heat content    
-      !--------------------
       ! Change the units of heat content; from J/m2 to J/m3
       DO jl = 1, jpl
@@ -109,5 +140,4 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  !0 if no ice and 1 if yes
                   rswitch = MAX(  0._wp , SIGN( 1._wp , v_i(ji,jj,jl) - epsi20 )  )
                   !Energy of melting q(S,T) [J.m-3]
@@ -119,5 +149,4 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  !0 if no ice and 1 if yes
                   rswitch = MAX(  0._wp , SIGN( 1._wp , v_s(ji,jj,jl) - epsi20 )  )
                   !Energy of melting q(S,T) [J.m-3]
@@ -128,6 +157,7 @@
       END DO
 
-      ! 2) Partial computation of forcing for the thermodynamic sea ice model.      !
-      !-----------------------------------------------------------------------------!
+      !--------------------------------------------------------------------!
+      ! Partial computation of forcing for the thermodynamic sea ice model
+      !--------------------------------------------------------------------!
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -148,5 +178,5 @@
 
             ! --- Energy from the turbulent oceanic heat flux (W/m2) --- !
-            zfric_u      = MAX( SQRT( ust2s(ji,jj) ), zfric_umin ) 
+            zfric_u      = MAX( SQRT( zfric(ji,jj) ), zfric_umin ) 
             fhtur(ji,jj) = MAX( 0._wp, rswitch * rau0 * rcp * zch  * zfric_u * ( ( sst_m(ji,jj) + rt0 ) - t_bo(ji,jj) ) ) ! W.m-2
             fhtur(ji,jj) = rswitch * MIN( fhtur(ji,jj), - zqfr * r1_rdtice / MAX( at_i(ji,jj), epsi10 ) )
@@ -166,15 +196,24 @@
             ENDIF
             !
-            ! -----------------------------------------
-            ! Net heat flux on top of ice-ocean [W.m-2]
-            ! -----------------------------------------
+            ! Net heat flux on top of the ice-ocean [W.m-2]
+            ! ---------------------------------------------
             hfx_in(ji,jj) = qns_tot(ji,jj) + qsr_tot(ji,jj) 
-
-            ! -----------------------------------------------------------------------------
-            ! Net heat flux on top of the ocean after ice thermo (1st step) [W.m-2]
-            ! -----------------------------------------------------------------------------
-            !     First  step here              :  non solar + precip - qlead - qturb
-            !     Second step in limthd_dh      :  heat remaining if total melt (zq_rema) 
-            !     Third  step in limsbc         :  heat from ice-ocean mass exchange (zf_mass) + solar
+         END DO
+      END DO
+      
+      ! In case we bypass open-water ice formation
+      IF( .NOT. ln_limdO )  qlead(:,:) = 0._wp
+      ! In case we bypass growing/melting from top and bottom: we suppose ice is impermeable => ocean is isolated from atmosphere
+      IF( .NOT. ln_limdH )  hfx_in(:,:) = pfrld(:,:) * ( qns_oce(:,:) + qsr_oce(:,:) ) + qemp_oce(:,:)
+      IF( .NOT. ln_limdH )  fhtur (:,:) = 0._wp  ;  fhld  (:,:) = 0._wp
+
+      ! ---------------------------------------------------------------------
+      ! Net heat flux on top of the ocean after ice thermo (1st step) [W.m-2]
+      ! ---------------------------------------------------------------------
+      !     First  step here              :  non solar + precip - qlead - qturb
+      !     Second step in limthd_dh      :  heat remaining if total melt (zq_rema) 
+      !     Third  step in limsbc         :  heat from ice-ocean mass exchange (zf_mass) + solar
+      DO jj = 1, jpj
+         DO ji = 1, jpi
             hfx_out(ji,jj) =   pfrld(ji,jj) * qns_oce(ji,jj) + qemp_oce(ji,jj)  &  ! Non solar heat flux received by the ocean               
                &             - qlead(ji,jj) * r1_rdtice                         &  ! heat flux taken from the ocean where there is open water ice formation
@@ -186,14 +225,10 @@
 
       !------------------------------------------------------------------------------!
-      ! 3) Select icy points and fulfill arrays for the vectorial grid.            
+      ! Thermodynamic computation (only on grid points covered by ice)
       !------------------------------------------------------------------------------!
 
       DO jl = 1, jpl      !loop over ice categories
 
-         IF( kt == nit000 .AND. lwp ) THEN
-            WRITE(numout,*) ' lim_thd : transfer to 1D vectors. Category no : ', jl 
-            WRITE(numout,*) ' ~~~~~~~~'
-         ENDIF
-
+         ! select ice covered grid points
          nbpb = 0
          DO jj = 1, jpj
@@ -208,5 +243,5 @@
          ! debug point to follow
          jiindex_1d = 0
-         IF( ln_icectl ) THEN
+         IF( ln_limctl ) THEN
             DO ji = mi0(iiceprt), mi1(iiceprt)
                DO jj = mj0(jiceprt), mj1(jiceprt)
@@ -217,43 +252,39 @@
          ENDIF
 
-         !------------------------------------------------------------------------------!
-         ! 4) Thermodynamic computation
-         !------------------------------------------------------------------------------!
-
-         IF( lk_mpp )   CALL mpp_ini_ice( nbpb , numout )
+         IF( lk_mpp )         CALL mpp_ini_ice( nbpb , numout )
 
          IF( nbpb > 0 ) THEN  ! If there is no ice, do nothing.
-            !
-            CALL lim_thd_1d2d( nbpb, jl, 1 )                ! --- Move to 1D arrays ---!
-            !
-            CALL lim_thd_dif ( 1, nbpb )                    ! --- Ice/Snow Temperature profile --- !
-            !
-            CALL lim_thd_dh  ( 1, nbpb )                    ! --- Ice/Snow thickness ---!
-            !
-            CALL lim_thd_ent ( 1, nbpb, q_i_1d(1:nbpb,:) )  ! --- Ice enthalpy remapping --- !
-            !
-            CALL lim_thd_sal ( 1, nbpb )                    ! --- Ice salinity ---            !
-            !
-            CALL lim_thd_temp( 1, nbpb )                    ! --- temperature update ---      !
-            !
-            !                                               ! --- lateral melting if monocat --- !
-            IF ( ( nn_monocat == 1 .OR. nn_monocat == 4 ) .AND. jpl == 1 ) THEN
-               CALL lim_thd_lam( 1, nbpb )
+            !                                                                
+            s_i_new   (:) = 0._wp ; dh_s_tot (:) = 0._wp                     ! --- some init --- !
+            dh_i_surf (:) = 0._wp ; dh_i_bott(:) = 0._wp
+            dh_snowice(:) = 0._wp ; dh_i_sub (:) = 0._wp
+
+                              CALL lim_thd_1d2d( nbpb, jl, 1 )               ! --- Move to 1D arrays --- !
+            !
+            IF( ln_limdH )    CALL lim_thd_dif( 1, nbpb )                    ! --- Ice/Snow Temperature profile --- !
+            !
+            IF( ln_limdH )    CALL lim_thd_dh( 1, nbpb )                     ! --- Ice/Snow thickness --- !    
+            !
+            IF( ln_limdH )    CALL lim_thd_ent( 1, nbpb, q_i_1d(1:nbpb,:) )  ! --- Ice enthalpy remapping --- !
+            !
+                              CALL lim_thd_sal( 1, nbpb )                    ! --- Ice salinity --- !    
+            !
+                              CALL lim_thd_temp( 1, nbpb )                   ! --- temperature update --- !
+            !
+            IF( ln_limdH ) THEN
+               IF ( ( nn_monocat == 1 .OR. nn_monocat == 4 ) .AND. jpl == 1 ) THEN
+                              CALL lim_thd_lam( 1, nbpb )                    ! --- extra lateral melting if monocat --- !
+               END IF
             END IF
             !
-            CALL lim_thd_1d2d( nbpb, jl, 2 )                ! --- Move to 2D arrays ---
-            !
-            IF( lk_mpp )   CALL mpp_comm_free( ncomm_ice )  !RB necessary ??
+                              CALL lim_thd_1d2d( nbpb, jl, 2 )               ! --- Move to 2D arrays --- !
+            !
+            IF( lk_mpp )      CALL mpp_comm_free( ncomm_ice ) !RB necessary ??
          ENDIF
          !
       END DO !jl
 
-      !------------------------------------------------------------------------------!
-      ! 5) Global variables, diagnostics
-      !------------------------------------------------------------------------------!
-
-      !------------------------
-      ! Ice heat content              
-      !------------------------
+      IF( ln_limdA)           CALL lim_thd_da                                ! --- lateral melting --- !
+
       ! Enthalpies are global variables we have to readjust the units (heat content in J/m2)
       DO jl = 1, jpl
@@ -261,11 +292,4 @@
             e_i(:,:,jk,jl) = e_i(:,:,jk,jl) * a_i(:,:,jl) * ht_i(:,:,jl) * r1_nlay_i
          END DO
-      END DO
-
-      !------------------------
-      ! Snow heat content              
-      !------------------------
-      ! Enthalpies are global variables we have to readjust the units (heat content in J/m2)
-      DO jl = 1, jpl
          DO jk = 1, nlay_s
             e_s(:,:,jk,jl) = e_s(:,:,jk,jl) * a_i(:,:,jl) * ht_s(:,:,jl) * r1_nlay_s
@@ -273,7 +297,5 @@
       END DO
  
-      !----------------------------------
       ! Change thickness to volume
-      !----------------------------------
       v_i(:,:,:)   = ht_i(:,:,:) * a_i(:,:,:)
       v_s(:,:,:)   = ht_s(:,:,:) * a_i(:,:,:)
@@ -292,100 +314,36 @@
       CALL lim_var_zapsmall
 
-      !--------------------------------------------
-      ! Diagnostic thermodynamic growth rates
-      !--------------------------------------------
-      IF( ln_icectl )   CALL lim_prt( kt, iiceprt, jiceprt, 1, ' - ice thermodyn. - ' )   ! control print
-
-      IF(ln_ctl) THEN            ! Control print
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Cell values : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=e1e2t, clinfo1=' lim_thd  : cell area :')
-         CALL prt_ctl(tab2d_1=at_i , clinfo1=' lim_thd  : at_i      :')
-         CALL prt_ctl(tab2d_1=vt_i , clinfo1=' lim_thd  : vt_i      :')
-         CALL prt_ctl(tab2d_1=vt_s , clinfo1=' lim_thd  : vt_s      :')
-         DO jl = 1, jpl
-            CALL prt_ctl_info(' ')
-            CALL prt_ctl_info(' - Category : ', ivar1=jl)
-            CALL prt_ctl_info('   ~~~~~~~~~~')
-            CALL prt_ctl(tab2d_1=a_i   (:,:,jl)   , clinfo1= ' lim_thd  : a_i      : ')
-            CALL prt_ctl(tab2d_1=ht_i  (:,:,jl)   , clinfo1= ' lim_thd  : ht_i     : ')
-            CALL prt_ctl(tab2d_1=ht_s  (:,:,jl)   , clinfo1= ' lim_thd  : ht_s     : ')
-            CALL prt_ctl(tab2d_1=v_i   (:,:,jl)   , clinfo1= ' lim_thd  : v_i      : ')
-            CALL prt_ctl(tab2d_1=v_s   (:,:,jl)   , clinfo1= ' lim_thd  : v_s      : ')
-            CALL prt_ctl(tab2d_1=e_s   (:,:,1,jl) , clinfo1= ' lim_thd  : e_s      : ')
-            CALL prt_ctl(tab2d_1=t_su  (:,:,jl)   , clinfo1= ' lim_thd  : t_su     : ')
-            CALL prt_ctl(tab2d_1=t_s   (:,:,1,jl) , clinfo1= ' lim_thd  : t_snow   : ')
-            CALL prt_ctl(tab2d_1=sm_i  (:,:,jl)   , clinfo1= ' lim_thd  : sm_i     : ')
-            CALL prt_ctl(tab2d_1=smv_i (:,:,jl)   , clinfo1= ' lim_thd  : smv_i    : ')
-            DO jk = 1, nlay_i
-               CALL prt_ctl_info(' ')
-               CALL prt_ctl_info(' - Layer : ', ivar1=jk)
-               CALL prt_ctl_info('   ~~~~~~~')
-               CALL prt_ctl(tab2d_1=t_i(:,:,jk,jl) , clinfo1= ' lim_thd  : t_i      : ')
-               CALL prt_ctl(tab2d_1=e_i(:,:,jk,jl) , clinfo1= ' lim_thd  : e_i      : ')
-            END DO
-         END DO
-      ENDIF
-      !
-      !
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limthd', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
-      !------------------------------------------------------------------------------|
-      !  6) Transport of ice between thickness categories.                           |
-      !------------------------------------------------------------------------------|
+      ! control checks
+      IF( ln_limctl )    CALL lim_prt( kt, iiceprt, jiceprt, 1, ' - ice thermodyn. - ' )   ! control print
+      !
+      IF( ln_limdiachk ) CALL lim_cons_hsm(1, 'limthd', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+
+      !------------------------------------------------!
+      !  Transport ice between thickness categories
+      !------------------------------------------------!
       ! Given thermodynamic growth rates, transport ice between thickness categories.
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(0, 'limitd_th_rem', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_limdiachk ) CALL lim_cons_hsm(0, 'limitd_th_rem', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
       IF( jpl > 1 )      CALL lim_itd_th_rem( 1, jpl, kt )
 
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limitd_th_rem', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
-      !------------------------------------------------------------------------------|
-      !  7) Add frazil ice growing in leads.
-      !------------------------------------------------------------------------------|
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(0, 'limthd_lac', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
-      CALL lim_thd_lac
+      IF( ln_limdiachk ) CALL lim_cons_hsm(1, 'limitd_th_rem', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+
+      !------------------------------------------------!
+      !  Add frazil ice growing in leads
+      !------------------------------------------------!
+      IF( ln_limdiachk ) CALL lim_cons_hsm(0, 'limthd_lac', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+
+      IF( ln_limdO )     CALL lim_thd_lac
       
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(1, 'limthd_lac', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      ! conservation test
+      IF( ln_limdiachk ) CALL lim_cons_hsm(1, 'limthd_lac', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
       ! Control print
-      IF(ln_ctl) THEN
-         CALL lim_var_glo2eqv
-
-         CALL prt_ctl_info(' ')
-         CALL prt_ctl_info(' - Cell values : ')
-         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
-         CALL prt_ctl(tab2d_1=e1e2t, clinfo1=' lim_itd_th  : cell area :')
-         CALL prt_ctl(tab2d_1=at_i , clinfo1=' lim_itd_th  : at_i      :')
-         CALL prt_ctl(tab2d_1=vt_i , clinfo1=' lim_itd_th  : vt_i      :')
-         CALL prt_ctl(tab2d_1=vt_s , clinfo1=' lim_itd_th  : vt_s      :')
-         DO jl = 1, jpl
-            CALL prt_ctl_info(' ')
-            CALL prt_ctl_info(' - Category : ', ivar1=jl)
-            CALL prt_ctl_info('   ~~~~~~~~~~')
-            CALL prt_ctl(tab2d_1=a_i   (:,:,jl)   , clinfo1= ' lim_itd_th  : a_i      : ')
-            CALL prt_ctl(tab2d_1=ht_i  (:,:,jl)   , clinfo1= ' lim_itd_th  : ht_i     : ')
-            CALL prt_ctl(tab2d_1=ht_s  (:,:,jl)   , clinfo1= ' lim_itd_th  : ht_s     : ')
-            CALL prt_ctl(tab2d_1=v_i   (:,:,jl)   , clinfo1= ' lim_itd_th  : v_i      : ')
-            CALL prt_ctl(tab2d_1=v_s   (:,:,jl)   , clinfo1= ' lim_itd_th  : v_s      : ')
-            CALL prt_ctl(tab2d_1=e_s   (:,:,1,jl) , clinfo1= ' lim_itd_th  : e_s      : ')
-            CALL prt_ctl(tab2d_1=t_su  (:,:,jl)   , clinfo1= ' lim_itd_th  : t_su     : ')
-            CALL prt_ctl(tab2d_1=t_s   (:,:,1,jl) , clinfo1= ' lim_itd_th  : t_snow   : ')
-            CALL prt_ctl(tab2d_1=sm_i  (:,:,jl)   , clinfo1= ' lim_itd_th  : sm_i     : ')
-            CALL prt_ctl(tab2d_1=smv_i (:,:,jl)   , clinfo1= ' lim_itd_th  : smv_i    : ')
-            DO jk = 1, nlay_i
-               CALL prt_ctl_info(' ')
-               CALL prt_ctl_info(' - Layer : ', ivar1=jk)
-               CALL prt_ctl_info('   ~~~~~~~')
-               CALL prt_ctl(tab2d_1=t_i(:,:,jk,jl) , clinfo1= ' lim_itd_th  : t_i      : ')
-               CALL prt_ctl(tab2d_1=e_i(:,:,jk,jl) , clinfo1= ' lim_itd_th  : e_i      : ')
-            END DO
-         END DO
-      ENDIF
-      !
-      IF( nn_timing == 1 )   CALL timing_stop('limthd')
-      !
+      IF( ln_ctl )       CALL lim_prt3D( 'limthd' )
+      !
+      CALL wrk_dealloc( jpi,jpj, zu_io, zv_io, zfric )
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('limthd')
+
    END SUBROUTINE lim_thd 
 
@@ -449,5 +407,5 @@
             zda_mel     = rswitch * a_i_1d(ji) * zdh_mel / ( 2._wp * MAX( zhi_bef, epsi20 ) )
             a_i_1d(ji)  = MAX( epsi20, a_i_1d(ji) + zda_mel ) 
-             ! adjust thickness
+            ! adjust thickness
             ht_i_1d(ji) = zvi / a_i_1d(ji)            
             ht_s_1d(ji) = zvs / a_i_1d(ji)            
@@ -613,15 +571,9 @@
       !!-------------------------------------------------------------------
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      !!
-      NAMELIST/namicethd/ rn_hnewice, ln_frazil, rn_maxfrazb, rn_vfrazb, rn_Cfrazb,                &
-         &                rn_himin, rn_betas, rn_kappa_i, nn_conv_dif, rn_terr_dif, nn_ice_thcon,  &
-         &                nn_monocat, ln_it_qnsice
+      NAMELIST/namicethd/ rn_kappa_i, nn_conv_dif, rn_terr_dif, nn_ice_thcon,ln_it_qnsice,nn_monocat,  &
+         &                ln_limdH, rn_betas,                                                          &
+         &                ln_limdA, rn_beta, rn_dmin,                                                  &
+         &                ln_limdO, rn_hnewice, ln_frazil, rn_maxfrazb, rn_vfrazb, rn_Cfrazb, rn_himin
       !!-------------------------------------------------------------------
-      !
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'lim_thd : Ice Thermodynamics'
-         WRITE(numout,*) '~~~~~~~'
-      ENDIF
       !
       REWIND( numnam_ice_ref )              ! Namelist namicethd in reference namelist : Ice thermodynamics
@@ -642,5 +594,22 @@
       IF(lwp) THEN                          ! control print
          WRITE(numout,*)
-         WRITE(numout,*)'   Namelist of ice parameters for ice thermodynamic computation '
+         WRITE(numout,*) 'lim_thd_init : Ice Thermodynamics'
+         WRITE(numout,*) '~~~~~~~~~~~~~'
+         WRITE(numout,*)'   -- limthd_dif --'
+         WRITE(numout,*)'      extinction radiation parameter in sea ice               rn_kappa_i   = ', rn_kappa_i
+         WRITE(numout,*)'      maximal n. of iter. for heat diffusion computation      nn_conv_dif  = ', nn_conv_dif
+         WRITE(numout,*)'      maximal err. on T for heat diffusion computation        rn_terr_dif  = ', rn_terr_dif
+         WRITE(numout,*)'      switch for comp. of thermal conductivity in the ice     nn_ice_thcon = ', nn_ice_thcon
+         WRITE(numout,*)'      iterate the surface non-solar flux (T) or not (F)       ln_it_qnsice = ', ln_it_qnsice
+         WRITE(numout,*)'      virtual ITD mono-category parameterizations (1) or not  nn_monocat   = ', nn_monocat
+         WRITE(numout,*)'   -- limthd_dh --'
+         WRITE(numout,*)'      activate ice thick change from top/bot (T) or not (F)   ln_limdH     = ', ln_limdH
+         WRITE(numout,*)'      coefficient for ice-lead partition of snowfall          rn_betas     = ', rn_betas
+         WRITE(numout,*)'   -- limthd_da --'
+         WRITE(numout,*)'      activate lateral melting (T) or not (F)                 ln_limdA     = ', ln_limdA
+         WRITE(numout,*)'      Coef. beta for lateral melting param.                   rn_beta      = ', rn_beta
+         WRITE(numout,*)'      Minimum floe diameter for lateral melting param.        rn_dmin      = ', rn_dmin
+         WRITE(numout,*)'   -- limthd_lac --'
+         WRITE(numout,*)'      activate ice growth in open-water (T) or not (F)        ln_limdO     = ', ln_limdO
          WRITE(numout,*)'      ice thick. for lateral accretion                        rn_hnewice   = ', rn_hnewice
          WRITE(numout,*)'      Frazil ice thickness as a function of wind or not       ln_frazil    = ', ln_frazil
@@ -648,14 +617,7 @@
          WRITE(numout,*)'      Thresold relative drift speed for collection of frazil  rn_vfrazb    = ', rn_vfrazb
          WRITE(numout,*)'      Squeezing coefficient for collection of frazil          rn_Cfrazb    = ', rn_Cfrazb
+         WRITE(numout,*)'   -- limitd_th --'
          WRITE(numout,*)'      minimum ice thickness                                   rn_himin     = ', rn_himin 
-         WRITE(numout,*)'      numerical carac. of the scheme for diffusion in ice '
-         WRITE(numout,*)'      coefficient for ice-lead partition of snowfall          rn_betas     = ', rn_betas
-         WRITE(numout,*)'      extinction radiation parameter in sea ice               rn_kappa_i   = ', rn_kappa_i
-         WRITE(numout,*)'      maximal n. of iter. for heat diffusion computation      nn_conv_dif  = ', nn_conv_dif
-         WRITE(numout,*)'      maximal err. on T for heat diffusion computation        rn_terr_dif  = ', rn_terr_dif
-         WRITE(numout,*)'      switch for comp. of thermal conductivity in the ice     nn_ice_thcon = ', nn_ice_thcon
          WRITE(numout,*)'      check heat conservation in the ice/snow                 con_i        = ', con_i
-         WRITE(numout,*)'      virtual ITD mono-category parameterizations (1) or not  nn_monocat   = ', nn_monocat
-         WRITE(numout,*)'      iterate the surface non-solar flux (T) or not (F)       ln_it_qnsice = ', ln_it_qnsice
       ENDIF
       !
